SystemOrganization addCategory: #KomPackaging!


Notification subclass: #InstallOptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KomPackaging'!

PackageInfo subclass: #KomPackageInfo
	instanceVariableNames: 'buildNumber buildDirectory snapshotDirectory publishDirectory '
	classVariableNames: 'RootBuildDirectory '
	poolDictionaries: ''
	category: 'KomPackaging'!

Url subclass: #KomPackageUrl
	instanceVariableNames: 'name version '
	classVariableNames: 'LastUpdateDate Registry '
	poolDictionaries: ''
	category: 'KomPackaging'!

KomPackageInfo subclass: #KomPackagingInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KomPackaging'!

KomPackageUrl subclass: #KomSqueakMapUrl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KomPackaging'!

Object subclass: #VersionHistory
	instanceVariableNames: 'versions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KomPackaging'!

Magnitude subclass: #VersionNumber
	instanceVariableNames: 'numbers '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KomPackaging'!

InstallOptions class
	instanceVariableNames: ''!

KomPackageInfo class
	instanceVariableNames: ''!

KomPackageUrl class
	instanceVariableNames: ''!

KomPackagingInfo class
	instanceVariableNames: ''!

KomSqueakMapUrl class
	instanceVariableNames: ''!

VersionHistory class
	instanceVariableNames: ''!

VersionNumber class
	instanceVariableNames: ''!


!InstallOptions commentStamp: 'svp 5/5/2003 14:10' prior: 0!
Usage:

	InstallOptions do: 
		[ :opts |
		opts at: 'silent' put: true.
		opts at: 'loadPrerequisites' put: false.
		"do the installation here"]!

!KomPackagingInfo commentStamp: 'svp 5/15/2003 23:38' prior: 0!
KomPackaging provides a number of utilities for managing PackageInfo (DVS) / SAR based packages.  It enables single click building and publishing, pre-requisite management,  pre-requisite auto installation, headles installation, optional installation of SUnit based test classes, install time unit test execution, and optional package installation, package registry, url based package addressing, generation of release notes (i.e. what you're reading right now), and many other things.  Not much time was spent developing a robust UI for all of these capabilities however.

Package URLs:

This package adds support for two types of urls, package and squeakmap...they take the forms:

	sqpkg://httpserver.kom:6.1
	sqmap://Named Process:1.1

You can do interesting things with these URLs, such as install them:

	'sqpkg://httpserver.kom:6.1' asUrl install

or, query whether or not a version of the package is currently installed:

	'sqpkg://httpserver.kom:6.1' asUrl isPresent

Version 1.0:
	- initial version!

!VersionHistory commentStamp: '<historical>' prior: 0!
I am a version history.  A version history is a collection of VersionNumbers that together form a tree of versions.  I enforce rules about how versions are added and removed from the history.

To add a new version to a VersionHistory based on an existing version:

  VersionHistory startingAt1 addNewVersionBasedOn: '1' asVersion; yourself

If you add 2 new versions based on the same version, a branch will be started:

  VersionHistory startingAt1 
		addNewVersionBasedOn: '1' asVersion;
		addNewVersionBasedOn: '1' asVersion; 
		yourself

To remove a single version (note: only versions at the tip of a branch, or at the base of the trunk (if it has only one successor) can be individually removed):

  VersionHistory startingAt1 
		addNewVersionBasedOn: '1' asVersion;
		addNewVersionBasedOn: '1' asVersion; 
		remove: '1.1' asVersion;
		yourself

To remove an entire branch:

  VersionHistory startingAt1 
		addNewVersionBasedOn: '1' asVersion;
		addNewVersionBasedOn: '1' asVersion; 
		addNewVersionBasedOn: '1.1' asVersion; 
		addNewVersionBasedOn: '1.2' asVersion; 
		removeBranch: '1.1' asVersion;
		yourself

To remove a portion of the trunk:

  VersionHistory startingAt1 
		addNewVersionBasedOn: '1' asVersion;
		addNewVersionBasedOn: '2' asVersion; 
		addNewVersionBasedOn: '3' asVersion; 
		addNewVersionBasedOn: '3' asVersion; 
		removeTrunk: '2' asVersion;
		yourself

To get a string description of a version history:

  VersionHistory startingAt1 
		addNewVersionBasedOn: '1' asVersion;
		addNewVersionBasedOn: '2' asVersion; 
		addNewVersionBasedOn: '3' asVersion; 
		addNewVersionBasedOn: '3' asVersion; 
		treeString

Also, the following methods are useful for accessing the versions:

	#firstVersion
	#versionBefore:
	#versionsAfter:
	#mainLineStartingAt:
	#allVersionsAfter:
	#allVersionsBefore:
!

!VersionNumber commentStamp: '<historical>' prior: 0!
I am a version number.  My representation allows me to handle an entire tree of versions.  Once created, an instance should not change (note: VersionNumbers could be canonicalized like Symbols, but are not currently).  

I am a magnitude so that you can see if one version preceeds another (only if the two versions are in the same branch).  

	'2.1' asVersion < '2.2.1' asVersion	"true"
	'2.3' asVersion < '2.2.1' asVersion	"error different branches"
	'2.3' asVersion inSameBranchAs: '2.2.1' asVersion	"false, why the previous one failed."	
	'2.1' asVersion = '2.1' asVersion		"true, obviously"

To get the next version number in the same branch:

	'2.3.4' asVersion next	"2.3.5"

To get the next version number, starting a new branch:

	'2.3.4' asVersion branchNext		"2.3.4.1"

To get the common base version of any two version numbers (useful for merging):

	'2.3.8' asVersion commonBase: '2.3.4.1' asVersion		"2.3.4"!

!VersionNumber methodsFor: 'comparing' stamp: 'svp 6/18/2002 15:05'!
< another 
	"Answer whether the receiver is less than the argument."

	| tmp |
	(self inSameBranchAs: another) ifFalse: 
		[^self error: 'Receiver and argument in different branches'].

	tmp := another numbers.
	(tmp size = numbers size) ifTrue:
		[1 to: numbers size do: 
			[ :in | (numbers at: in) < (tmp at: in) ifTrue: [^true]].
		^false].

	^numbers size < tmp size
! !

!VersionNumber methodsFor: 'comparing' stamp: 'svp 6/18/2002 15:10'!
= aVersion

	^numbers = aVersion numbers! !

!VersionHistory methodsFor: 'adding' stamp: 'svp 6/18/2002 17:17'!
addNewVersionBasedOn: aVersion

	| tmp |
	(versions includes: aVersion) ifFalse: [^self error: 'Version is not in this history'].

	tmp := aVersion next.
	(versions includes: tmp) ifFalse: 
		[versions add: tmp.
		^tmp].

	tmp := aVersion.
	[versions includes: (tmp := tmp branchNext)] whileTrue.
	versions add: tmp.
	^tmp
	! !

!VersionHistory methodsFor: 'accessing' stamp: 'svp 6/26/2002 16:32'!
allVersionsAfter: aVersion
	"Answer all the versions based on aVersion."

	| answer |
	answer := Set new.
	versions do: [ :ea |
		((ea inSameBranchAs: aVersion) and: 
			[ea > aVersion]) ifTrue: [answer add: ea]].
	^answer! !

!VersionHistory methodsFor: 'accessing' stamp: 'svp 6/26/2002 16:32'!
allVersionsBefore: aVersion
	"Answer all versions that came before aVersion"

	| answer |
	answer := Set new.
	versions do: [ :ea |
		((ea inSameBranchAs: aVersion) and: 
			[ea < aVersion]) ifTrue: [answer add: ea]].
	^answer! !

!String methodsFor: '*KomPackaging' stamp: 'svp 6/18/2002 16:12'!
asVersion
	"Answer a VersionNumber"

	^VersionNumber fromString: self! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 14:57'!
assureExistenceOfBuildDirectory

	self buildDirectory assureExistence

! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/6/2003 01:22'!
at: aKey

	^self current at: aKey ifAbsent: [self error: 'key not found']! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/6/2003 01:21'!
at: aKey ifAbsent: absentBlock

	^self current at: aKey ifAbsent: absentBlock! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/6/2003 01:25'!
at: aKey ifAbsentPut: absentBlock

	^self current at: aKey ifAbsentPut: absentBlock! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/6/2003 01:21'!
at: aKey put: anObject

	^self current at: aKey put: anObject! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:28'!
baseUrl

	^(self class resolve: self name) asUrl! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/6/2003 01:21'!
beSilent

	^self at: #beSilent ifAbsent: [false]! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/6/2003 01:22'!
beSilent: aBoolean

	^self at: #beSilent put: aBoolean! !

!VersionNumber methodsFor: 'accessing' stamp: 'svp 6/18/2002 12:22'!
branchNext

	^self class fromCollection: (numbers, (Array with: 1))! !

!KomPackageInfo class methodsFor: 'as yet unclassified' stamp: 'svp 5/8/2003 22:06'!
browsePrereq: prereqName

	MessageSet 
		openMessageList:
			(OrderedCollection with:
				(MethodReference new
					setClass: self
					methodSymbol: #prerequisites
					stringVersion: ''))
		name: (self class name, '>>prerequisites')
		autoSelect: prereqName

	! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/20/2003 16:21'!
buildDirectory

	^buildDirectory
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/20/2003 16:21'!
buildDirectory: aFileDirectoryOrString

	buildDirectory := aFileDirectoryOrString isString
			ifTrue: [FileDirectory on: aFileDirectoryOrString]
			ifFalse: [aFileDirectoryOrString]
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 15:58'!
buildFileName

	^self buildFileNameFor: self buildNumber
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 15:58'!
buildFileNameFor: aVersionNumber

	^self buildDirectory fullNameFor: 
		(self packageName, '-bld', aVersionNumber versionString, '.sar')! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 15:23'!
buildHistory

	| in |
	^VersionHistory fromCollection:
		((self buildDirectory fileNamesMatching: (self packageName, '-bld*.sar'))
			collect: 
				[ :ea | 
				in := ea indexOfSubCollection: '-bld' startingAt: 1.
				(ea copyFrom: (in + 4) to: (ea size - 4)) asVersion]).
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 14:27'!
buildNumber

	^buildNumber! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 15:26'!
buildNumber: aVersionNumber

	buildNumber := aVersionNumber! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 21:57'!
buildNumberString

	^(self buildNumber ifNil: [^'0']) versionString! !

!VersionHistory methodsFor: 'testing' stamp: 'svp 6/27/2002 14:09'!
canRemove: aVersion

	| hasPriors followers |
	(versions includes: aVersion) ifFalse: [^false].
	hasPriors := (self versionBefore: aVersion) notNil.
	followers := self versionsAfter: aVersion.		

	"Don't allow versions in the middle to be extracted"
	(hasPriors and: [followers size > 0]) ifTrue: [^false].
	
	"Don't allow versions with more than one follower to be extracted"
	(hasPriors not and: [followers size > 1]) ifTrue: [^false].
	^true

! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:16'!
categoryName

	^self installedPackageInfo 
		ifNotNilDo: [ :pi | pi packageName]! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/6/2003 01:23'!
clamp: aBlock

	| opts |
	opts := Dictionary new.
	[aBlock value: opts]
		on: InstallOptions
		do: [ :io | io resume: opts ]! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/9/2003 16:25'!
classes
	| answer |
	answer := self systemCategories gather:
		[:cat |
		(SystemOrganization listAtCategoryNamed: cat)
			collect: [:className | Smalltalk at: className]].
	Smalltalk at: #TestCase ifPresent: 
		[ :tcClass |
		^answer select: [ :cls | (cls inheritsFrom: tcClass) not]].
	^answer
! !

!VersionNumber methodsFor: 'accessing' stamp: 'svp 6/18/2002 14:50'!
commonBase: aVersion

	| smallNums largeNums cutoff |
	(aVersion numbers size <= numbers size) 
		ifTrue: [smallNums := aVersion numbers. largeNums := numbers] 
		ifFalse: [smallNums := numbers. largeNums := aVersion numbers].

	cutoff := (1 to: smallNums size) 
		detect: [ :in | ((smallNums at: in) ~= (largeNums at: in))] 
		ifNone: [^self class fromCollection: smallNums].

	^self class fromCollection: 
		((numbers copyFrom: 1 to: (cutoff - 1)), 
		(Array with: ((smallNums at: cutoff) min: (largeNums at: cutoff))))
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 9/23/2003 01:32'!
conditionalChangeSets
	"Subclass to answer an array of two item arrays.  The first item is a string
	of valid Smalltalk code that should evaluate to a boolean.  The second item is 
	a string that specifies a change set name.  The change sets specified may either
	reside in the image, or as a file in the default directory."

	^#()! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/5/2003 14:04'!
current

	^self signal ifNil: [Dictionary new]! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/20/2003 16:53'!
definition

	^String streamContents: 
		[ :strm |
		strm nextPutAll: self class name.
		strm nextPutAll: ' default'.
		strm cr.
		strm nextPutAll: '	buildDirectory: '.
		strm nextPutAll: self buildDirectory fullName printString.
		strm cr.
		strm nextPutAll: '	publishDirectory: '.
		strm nextPutAll: self publishDirectory fullName printString.
		strm cr.
		strm nextPutAll: '	releaseName: '.
		strm nextPutAll: self releaseName printString.
		strm cr.
		strm nextPutAll: '	maturity: '.
		strm nextPutAll: self maturity printString.
		strm cr.
		strm nextPutAll: '	prerequisites: '.
		strm nextPutAll: self prerequisites printString].! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:27'!
downloadUrl

	| tmp |
	tmp := self baseUrl.
	tmp path at: tmp path size put: (tmp path last, '-', self version, '.sar').
	^tmp
! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 9/23/2003 02:17'!
errorWrongVersion

	"We need to add mechanisms for loading package configurations (until then, don't
	worry about wrong versions of pre-reqs"

	"self error: ('version ', self installedVersion, ' of ', self packageName, 
		'is installed, but version ', self version, ' is required')"! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/6/2003 00:42'!
fileOutOnStream: strm

	super fileOutOnStream: strm.
	strm nextChunkPut: 
		('Smalltalk at: #FilePackageManager ifPresent: [ :p | p registerPackage: ', self packageName printString, '].').
	strm cr.
	strm nextChunkPut:
		('Smalltalk at: #KomPackageInfo ifPresent: [ :p | (p named: ', self packageName printString, ') buildNumber: ', self buildNumber printString, '].').
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/9/2003 16:34'!
fileOutSunitOnStream: aStream
	
	(ChangeSet superclassOrder: self sunitClassesAndMetaClasses)
		do: [:class | aStream nextChunkPut: class definition; cr; cr]
		displayingProgress: 'Filing out classes...'.
	
	self sunitClasses do:
		[:class |
		class organization classComment isEmpty
			ifFalse: [class organization putCommentOnFile: aStream numbered: 0 moveSource: false forClass: class]].
		
	(self sunitMethods sortBy:
		[:a :b | a methodSymbol < b methodSymbol or: [a methodSymbol = b methodSymbol and: [a classSymbol <= b classSymbol]]])
			do: [:ref | ref actualClass
							printMethodChunk: ref methodSymbol
							withPreamble: true
							on: aStream
							moveSource: false toFile: 0]
			displayingProgress: 'Filing out methods...'.
	
	(self sunitClasses select: [:c | c class includesSelector: #initialize])
		do: [:class | aStream nextChunkPut: class name, ' initialize'; cr].! !

!VersionNumber class methodsFor: 'as yet unclassified' stamp: 'svp 6/18/2002 16:34'!
first

	^self fromCollection: #(1)! !

!VersionHistory methodsFor: 'accessing' stamp: 'svp 6/26/2002 16:32'!
firstVersion
	"Answer the first version in the entire version history"

	^versions inject: versions anyOne into: [ :x :ea |
		(x inSameBranchAs: ea)
			ifTrue: [(x < ea) ifTrue: [x] ifFalse: [ea]]
			ifFalse: [ea]]! !

!VersionHistory class methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 15:39'!
fromCollection: aCollection
	"Note: this does not validate the continuity of version
	numbers passed in aCollection...need to add continuity
	checks in the future"

	^self new
		initializeVersionsFrom: aCollection;
		yourself! !

!VersionNumber class methodsFor: 'as yet unclassified' stamp: 'svp 6/18/2002 12:21'!
fromCollection: aCollection

	^self new
		initializeNumbers: aCollection;
		yourself! !

!VersionNumber class methodsFor: 'as yet unclassified' stamp: 'svp 6/18/2002 12:20'!
fromString: aString

	^self fromCollection: 
		((aString findTokens: '.') collect: [:ea | ea asNumber ])
	! !

!VersionNumber methodsFor: 'comparing' stamp: 'svp 6/18/2002 12:23'!
hash

	^numbers hash! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:33'!
ifNotPresent: notPresentBlock ifWrongVersion: wrongVersionBlock

	self isWrongVersionPresent ifTrue: [^wrongVersionBlock value].
	self isPresent ifFalse: [^notPresentBlock value].! !

!VersionNumber methodsFor: 'testing' stamp: 'svp 6/18/2002 14:57'!
inSameBranchAs: aVersion

	| less more |
	(aVersion numbers size <= numbers size) 
		ifTrue: [less := aVersion numbers. more := numbers] 
		ifFalse: [less := numbers. more := aVersion numbers].

	1 to: (less size - 1) do: [ :in | ((less at: in) = (more at: in)) ifFalse: [^false]].
	^less size = more size or:
		[(less at: less size) <= (more at: less size)]
! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/6/2003 01:22'!
includesKey: aKey

	^self current includesKey: aKey! !

!VersionHistory methodsFor: 'testing' stamp: 'svp 6/18/2002 16:43'!
includesVersion: aVersion

	^versions includes: aVersion! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 15:35'!
incrementBuildNumber

	buildNumber ifNil: [buildNumber := '1' asVersion. ^self].
	buildNumber := self buildHistory addNewVersionBasedOn: buildNumber! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:39'!
infoClass

	Smalltalk 
		at: (self packageName, 'Info') asSymbol
		ifPresent: 
			[ :infoClass | ^infoClass ].
	^nil! !

!VersionNumber methodsFor: 'initialization' stamp: 'svp 6/18/2002 15:08'!
initializeNumbers: aCollection

	aCollection do: [ :ea | 
		ea <= 0 ifTrue: 
			[^self error: 'VersionNumbers cannot contain zero or negative numbers']].

	numbers := aCollection asArray! !

!VersionHistory methodsFor: 'initialization' stamp: 'svp 6/18/2002 17:15'!
initializeVersionsAt: aVersion

	versions := Set new.
	versions add: aVersion.! !

!VersionHistory methodsFor: 'initialization' stamp: 'svp 5/5/2003 15:21'!
initializeVersionsFrom: aCollection

	versions := Set new.
	aCollection do: [ :ea | versions add: ea ].
! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:34'!
install

	SARInstaller installSARFromUrl: self downloadUrl! !

!KomSqueakMapUrl methodsFor: 'packaging' stamp: 'svp 5/9/2003 02:42'!
install

	SMSqueakMap default 
		installPackageNamed: self name.
	self smCard ifNotNilDo: 
		[ :card |
		(SMSqueakMap default installedVersionOf: card) = self version ifFalse:
			[self inform: ('Warning: prerequisite specified version ', 
				self version,'\',	'of ', card name,
				' but version ', card currentVersion,' is currently\',
				'registered on SqueakMap.  Incompatibilities\',
				'might exist and cause problems.') withCRs]]! !

!SARInstaller class methodsFor: '*KomPackaging' stamp: 'svp 5/6/2003 01:10'!
installSARFromUrl: aUrlOrString

	| url num tempFileName strm pkgName contents |
	url := aUrlOrString asUrl.
	contents := url retrieveContents contents.
	pkgName := url path last sansPeriodSuffix.
	num := 1.
	[FileDirectory default isAFileNamed: (tempFileName := pkgName, '.', num asString, '.temp')]
		whileTrue: [num := num + 1].

	[strm := FileStream newFileNamed: tempFileName.
	[strm nextPutAll: contents] ensure: [strm close].
	self installSAR: (FileDirectory default fullNameFor: tempFileName)]
		ensure: [FileDirectory default deleteFileNamed: tempFileName]
! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:39'!
installedPackageInfo

	^self infoClass ifNotNilDo: [ :ic | ic default ]! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:40'!
installedVersion

	^self installedPackageInfo ifNotNilDo: [ :pi | pi releaseName ]! !

!KomSqueakMapUrl methodsFor: 'packaging' stamp: 'svp 5/9/2003 02:42'!
installedVersion

	| ourCard |
	(ourCard := self smCard) ifNil: [^nil].
	^SMSqueakMap default installedVersionOf: ourCard! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:35'!
isCorrectVersionPresent

	^self isPresent and: [self isWrongVersionPresent not]! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/7/2003 09:23'!
isKomPackagingPackage

	^false! !

!KomPackagingInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/7/2003 09:23'!
isKomPackagingPackage

	^true! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:35'!
isPresent

	^Smalltalk includesKey: (self packageName, 'Info') asSymbol! !

!KomSqueakMapUrl methodsFor: 'packaging' stamp: 'svp 5/9/2003 03:56'!
isPresent

	^(self smCard ifNil: [^false]) isInstalled! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/20/2003 15:40'!
isStable

	^self maturity == #stable! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/20/2003 16:01'!
isStable

	self isPresent ifFalse: [^self error: 'Package is not loaded'].
	^self installedPackageInfo isStable.
! !

!KomSqueakMapUrl methodsFor: 'packaging' stamp: 'svp 5/20/2003 16:00'!
isStable
	"Assume that any non KomPackageInfo is stable"
 
	^true! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/20/2003 15:40'!
isUnstable

	^self maturity ~~ #stable! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:40'!
isWrongVersionPresent

	| iv |
	(iv := self installedVersion) ifNil: [^false].
	^iv ~= self version
! !

!VersionHistory methodsFor: 'accessing' stamp: 'svp 5/5/2003 15:55'!
latestMainLineVersion

	^(self mainLineStartingAt: self firstVersion) last! !

!KomPackageUrl class methodsFor: 'name resolution' stamp: 'svp 5/9/2003 04:06'!
loadRegistry

	| lines newReg |
	lines := (self registryUrl retrieveContents contents) findTokens: String crlf.
	lines := lines select: [ :ea | ea withBlanksTrimmed isEmpty not].
	newReg := Dictionary new.
	lines do: 
		[ :line |
		newReg 
			at: (line copyUpTo: $:) withBlanksTrimmed 
			put: (line copyAfter: $:) withBlanksTrimmed].
	LastUpdateDate := Date today.
	^Registry := newReg.
! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 9/23/2003 01:51'!
loadTestClasses

	^(self at: #loadTestClasses ifAbsentPut: [true])
		and: [Smalltalk includesKey: #TestCase]! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/9/2003 17:06'!
log: aString

	| logger |
	(logger := self logger) nextPutAll: aString.
	logger flush.
	logger == Transcript ifTrue: [logger endEntry].
! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/9/2003 16:48'!
logger

	^self at: #logger ifAbsentPut: [Transcript]! !

!VersionHistory methodsFor: 'accessing' stamp: 'svp 6/26/2002 16:35'!
mainLineStartingAt: aVersion
	"Answer all versions based on aVersion that are not branches (they have 
	the same number of digits with the same values, except the last value is
	greater than the last value of aVersion)."

	| answer tmp |
	answer := OrderedCollection new.
	tmp := aVersion.
	[versions includes: tmp] 
		whileTrue: 
			[answer add: tmp.
			tmp := tmp next].
	^answer
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 16:32'!
manager

	^PackageManager named: self packageName! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/20/2003 15:33'!
maturity
	"<#alpha | #beta | #gamma | #stable> Answers a symbol indicating the maturity
	of the package...packages listed as #stable indicate that no further builds of that
	release name should be allowed (attempts to build or publish #stable packages will
	fail).  Instead, change the release name and mark the package as something other
	than #stable.  Additionally, if a package is marked #stable, then validating 
	prerequisites will validate that all pre-requisite packages are also marked #stable.

	By default, packages are considered to be #alpha."

	^#alpha! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:14'!
name

	^name! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:14'!
name: aString

	name := aString! !

!VersionNumber methodsFor: 'accessing' stamp: 'svp 6/18/2002 12:14'!
next

	| tmp |
	tmp := numbers copy.
	tmp at: numbers size put: (numbers last + 1).
	^self class fromCollection: tmp! !

!VersionNumber methodsFor: 'accessing' stamp: 'svp 6/18/2002 14:51'!
numbers
	"Answer a copy (to discourage people from directly changing a version number).
	VersionNumbers should never change, instead, instantiate a new instance."

	^numbers copy! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/7/2003 11:02'!
optionalPackages

	^#()! !

!KomPackagingInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/9/2003 03:15'!
optionalPackages

^#(
('KomPackageBuilder' 'sqpkg://packageBuilder.kom:1.0'
'KomPackageBuilder is a useful package if you would like to use the
Comanche packaging system to build your own packages.  Would you
like to load this package now?')
)
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/7/2003 10:03'!
packageName

	(self class == (Smalltalk at: #KomPackageInfo)) ifTrue: [^'ABSTRACT'].
	^packageName ifNil: [packageName _ (self categoryName copyUpTo: $-) ]! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:15'!
packageName

	^self baseUrl path last! !

!KomSqueakMapUrl methodsFor: 'packaging' stamp: 'svp 5/9/2003 02:43'!
packageName

	^self name! !

!KomPackageUrl class methodsFor: 'as yet unclassified' stamp: 'svp 5/9/2003 00:54'!
packageName: pkgString version: verString

	^self new
		packageName: pkgString;
		version: verString;
		yourself! !

!HierarchicalUrl methodsFor: '*KomPackaging' stamp: 'svp 5/9/2003 02:06'!
pkgCategoryName

	^self pkgInstalledPackageInfo
		ifNotNilDo: [ :pi | pi packageName]
! !

!HierarchicalUrl methodsFor: '*KomPackaging' stamp: 'svp 5/9/2003 01:52'!
pkgFullUrl

	^(self printString, '-', self version, '.sar') asUrl

! !

!HierarchicalUrl methodsFor: '*KomPackaging' stamp: 'svp 5/9/2003 01:52'!
pkgInstall

	SARInstaller installSARFromUrl: self pkgFullUrl! !

!HierarchicalUrl methodsFor: '*KomPackaging' stamp: 'svp 5/9/2003 01:54'!
pkgInstalledPackageInfo

	Smalltalk 
		at: (self name, 'Info') asSymbol
		ifPresent: 
			[ :infoClass | ^infoClass default ].
	^nil! !

!KomSqueakMapUrl methodsFor: 'packaging' stamp: 'svp 5/9/2003 01:55'!
pkgInstalledPackageInfo

	^nil! !

!HierarchicalUrl methodsFor: '*KomPackaging' stamp: 'svp 5/9/2003 01:58'!
pkgInstalledVersion

	^self pkgInstalledPackageInfo 
		ifNotNilDo: [ :pi | pi releaseName ]! !

!HierarchicalUrl methodsFor: '*KomPackaging' stamp: 'svp 5/9/2003 01:58'!
pkgIsPresent

	^Smalltalk includesKey: (self pkgName, 'Info') asSymbol! !

!HierarchicalUrl methodsFor: '*KomPackaging' stamp: 'svp 5/9/2003 01:59'!
pkgName

	^self path last! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/8/2003 11:06'!
preloadChangeSetNames

	^#()! !

!KomPackagingInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/9/2003 03:33'!
preloadChangeSetNames

	^#('KomPackaging-preload.cs')! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/8/2003 11:15'!
preloadChangeSets

	^self preloadChangeSetNames collect: 
		[ :nm |
		(ChangeSorter changeSetNamed: nm) 
			ifNil: [self error: 'missing preload change set']]! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 22:09'!
prerequisiteNames

	^self prerequisites collect: [ :ea | ea first ]! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/6/2003 01:25'!
prerequisites

	^self at: #prerequisites ifAbsentPut: [Dictionary new]! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 22:08'!
prerequisites

	^#()! !

!VersionNumber methodsFor: 'accessing' stamp: 'svp 6/18/2002 16:51'!
previous

	| tmp |
	numbers last = 1 ifTrue: 
		[^self class fromCollection: (numbers allButLast)].
	tmp := numbers copy.
	tmp at: numbers size put: (numbers last - 1).
	^self class fromCollection: tmp
! !

!KomPackageUrl methodsFor: 'printing' stamp: 'svp 5/9/2003 03:45'!
printOn: strm

	strm 
		nextPutAll: self schemeName;
		nextPutAll: '://';
		nextPutAll: self name;
		nextPut: $:;
		nextPutAll: self version! !

!VersionNumber methodsFor: 'printing' stamp: 'svp 6/18/2002 12:27'!
printOn: strm

	self storeOn: strm! !

!KomPackageUrl methodsFor: 'private' stamp: 'svp 5/9/2003 03:44'!
privateInitializeFromText: aString

	| remainder ind schemeName |
	remainder _ aString.

	schemeName _ Url schemeNameForString: remainder.
	schemeName ifNotNil: [ 
		remainder _ remainder copyFrom: (schemeName size+2) to: remainder size ].

	"remove leading // if it's there"
	(remainder beginsWith: '//') ifTrue: [
		remainder _ remainder copyFrom: 3 to: remainder size ].

	"get the name"
	ind _ remainder indexOf: $/.
	ind > 0 ifTrue: [
		ind = 1 ifTrue: [ name _ '' ] ifFalse: [
			name _ remainder copyFrom: 1 to: ind-1.
			remainder _ remainder copyFrom: ind+1 to: remainder size. ] ]
	ifFalse: [
		name _ remainder.
		remainder _ ''. ].

	"Extract the version"
	(name includes: $:)
		ifTrue: [
			version _ (name copyFrom: (name indexOf: $:) + 1 to: name size).
			name _ name copyUpTo: $:].
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/7/2003 11:05'!
publish

	| srcName destName |

	"First copy the latest version"
	(self buildHistory includesVersion: self buildNumber)
		ifFalse: [^self inform: 'no build file matching the package in memory'].
	srcName := self buildFileName.
	destName := self publishFileName.
	FileDirectory default copyFileNamed: srcName toFileNamed: destName.

	"Now copy the readme.txt"
	srcName := self buildDirectory fullNameFor: (self packageName, '.txt').
	(FileStream isAFileNamed: srcName) ifFalse: [^self].
	destName := self publishDirectory fullNameFor: (self packageName, '-', self releaseName, '.txt').
	FileDirectory default copyFileNamed: srcName toFileNamed: destName.
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 16:10'!
publishDeveloperSnapshot

	| latestVersion srcName destName |
	latestVersion := self buildHistory latestMainLineVersion.
	srcName := self buildFileNameFor: latestVersion.
	destName := self snapshotFileName.
	FileDirectory default copyFileNamed: srcName toFileNamed: destName.! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 16:07'!
publishDirectory
	"Need to refactor to remove GUI code"

	| initialSelection |
	initialSelection := self buildDirectory.
	snapshotDirectory ifNotNil: [initialSelection := snapshotDirectory].
	publishDirectory ifNil: 
		[(FileList2 modalFolderSelector: initialSelection) 
			ifNotNilDo: [:dir | publishDirectory := dir ]].
	^publishDirectory! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/6/2003 00:56'!
publishFileName

	^self publishDirectory fullNameFor: 
		(self packageName, '-', self releaseName, '.sar')! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 15:03'!
readmeFileName

	^self buildDirectory fullNameFor: 
		(self packageName, '-bld', self buildNumber versionString, '.txt')! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 22:47'!
readmeText

	^self class comment asString
! !

!KomPackageUrl class methodsFor: 'name resolution' stamp: 'svp 5/9/2003 04:07'!
registry

	(LastUpdateDate ~= Date today or: [Registry isNil]) 
		ifTrue: [self loadRegistry].
	^Registry! !

!KomPackageUrl class methodsFor: 'name resolution' stamp: 'svp 5/9/2003 01:05'!
registryUrl

	^'http://people.advantive.com/~spair/squeak/PackageRegistry.txt' asUrl! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 14:30'!
releaseName
	"Subclasses should override this method to provide their
	own release names"

	^'1.0'! !

!KomPackagingInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 22:35'!
releaseName

	^'1.0'! !

!VersionHistory methodsFor: 'removing' stamp: 'svp 6/26/2002 16:30'!
remove: aVersion
	"Remove aVersion from this version history."

	^self remove: aVersion ifAbsent: [self error: 'version not found'].! !

!VersionHistory methodsFor: 'removing' stamp: 'svp 6/27/2002 14:08'!
remove: aVersion ifAbsent: aBlock
	"Remove aVersion from this version history."

	(versions includes: aVersion) ifFalse: [^aBlock value].

	(self canRemove: aVersion) ifFalse:
		[^self error: 'Only versions at the beginning or end with no more than one follower may be removed'].

	versions remove: aVersion.! !

!VersionHistory methodsFor: 'removing' stamp: 'svp 6/18/2002 17:48'!
removeBranch: aVersion
	"Remove aVersion and all of it's successors, providing that
	aVersion is not the first version."

	(self versionBefore: aVersion)
		ifNil: [^self error: 'version is the first version in the history'].

	versions removeAll: (self allVersionsAfter: aVersion).
	versions remove: aVersion.! !

!VersionHistory methodsFor: 'removing' stamp: 'svp 6/18/2002 17:47'!
removeTrunk: aVersion
	"Remove aVersion and all of it's predecessors, providing there
	are no other branches stemming from the trunk.  Note, a trunk is defined
	as all versions, starting with the first version, that have only one successor."

	| tmp |
	(self versionsAfter: aVersion) size > 1 
		ifTrue: [^self error: 'version is at a fork'].

	tmp := self allVersionsBefore: aVersion.
	(tmp detect: [ :ea | (self versionsAfter: ea) size > 1 ] ifNone: [nil])
		ifNotNil: [^self error: 'not a trunk, other branches detected'].

	versions removeAll: tmp.
	versions remove: aVersion.! !

!KomPackageUrl class methodsFor: 'name resolution' stamp: 'svp 5/9/2003 02:26'!
resetRegistry
	"self resetRegistry"

	Registry := nil! !

!KomPackageUrl class methodsFor: 'name resolution' stamp: 'svp 5/9/2003 01:16'!
resolve: aPackageName
	"Answers another URL that is the home of the package (all versions)"

	^self resolve: aPackageName ifAbsent: [self error: 'no such package']! !

!KomPackageUrl class methodsFor: 'name resolution' stamp: 'svp 5/9/2003 01:16'!
resolve: aPackageName ifAbsent: absentBlock
	"Answers another URL that is the home of the package (all versions)"

	^self registry at: aPackageName ifAbsent:
		["Reload the registry and try one more time"
		self loadRegistry.
		self registry at: aPackageName ifAbsent: absentBlock]
	! !

!KomPackageInfo class methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 14:15'!
rootBuildDirectory

	^RootBuildDirectory ifNil: [RootBuildDirectory := FileDirectory default]! !

!KomPackageInfo class methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 14:19'!
rootBuildDirectory: aFileDirectory
	"Sets the rootBuildDirectory...evaluate the following
	code to change the root build directory using a GUI"

	"(FileList2 modalFolderSelector: self rootBuildDirectory) 
		ifNotNilDo: [:dir | self rootBuildDirectory: dir ]"

	RootBuildDirectory := aFileDirectory! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/16/2003 09:48'!
runTestCases
	"This method is designed to be run at package install time"

	| suite testResults |
	(Smalltalk includesKey: #TestSuite) ifFalse: 
		[^self error: 'SUnit does not appear to be installed'].
	InstallOptions log: (self packageName, ': running SUnit tests (').
	suite := (Smalltalk at: #TestSuite) new.
	self sunitClasses do: [ :testClass | suite addTests: testClass suite tests].
	testResults _ suite run.
	InstallOptions log: testResults printString.
	(testResults errorCount > 0 or: [testResults failureCount > 0])
		ifTrue: 
			[InstallOptions log: (') FAILED!!', String cr)]
		ifFalse:
			[InstallOptions log: (') PASSED!!', String cr)].! !

!KomPackageInfo class methodsFor: 'as yet unclassified' stamp: 'svp 5/9/2003 17:00'!
runTestCases

	self default runTestCases! !

!InstallOptions class methodsFor: 'accessing' stamp: 'svp 5/9/2003 16:52'!
runTests

	^self at: #runTests ifAbsentPut: [true]! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 02:32'!
schemeName
	^'sqpkg'! !

!KomSqueakMapUrl methodsFor: 'packaging' stamp: 'svp 5/9/2003 02:32'!
schemeName
	^'sqmap'! !

!KomSqueakMapUrl methodsFor: 'packaging' stamp: 'svp 5/16/2003 10:15'!
smCard

	^SMSqueakMap default cardWithNameBeginning: self name! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 16:07'!
snapshotDirectory
	"Need to refactor to remove GUI code"

	| initialSelection |
	initialSelection := self buildDirectory.
	publishDirectory ifNotNil: [initialSelection := publishDirectory].
	snapshotDirectory ifNil: 
		[(FileList2 modalFolderSelector: initialSelection) 
			ifNotNilDo: [:dir | snapshotDirectory := dir ]].
	^snapshotDirectory! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 16:08'!
snapshotFileName

	^self snapshotDirectory fullNameFor: 
		(self packageName, '-latest.sar')! !

!VersionHistory class methodsFor: 'as yet unclassified' stamp: 'svp 6/26/2002 16:20'!
startingAt1

	^self startingAt: '1' asVersion! !

!VersionHistory class methodsFor: 'as yet unclassified' stamp: 'svp 6/18/2002 17:14'!
startingAt: aVersion

	^self new
		initializeVersionsAt: aVersion;
		yourself! !

!VersionNumber methodsFor: 'printing' stamp: 'svp 6/18/2002 17:24'!
storeOn: strm

	strm nextPut: $'.
	self versionStringOn: strm.
	strm nextPutAll: ''' asVersion'.! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/9/2003 16:26'!
sunitClasses
	| answer |
	answer := self systemCategories gather:
		[:cat |
		(SystemOrganization listAtCategoryNamed: cat)
			collect: [:className | Smalltalk at: className]].
	Smalltalk at: #TestCase ifPresent: 
		[ :tcClass |
		^answer select: [ :cls | cls inheritsFrom: tcClass]].
	^#()
! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/9/2003 16:27'!
sunitClassesAndMetaClasses
	| baseClasses |
	baseClasses := self sunitClasses.
	^baseClasses , (baseClasses collect: [:c | c class])! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/9/2003 16:28'!
sunitMethods
	^ self sunitClassesAndMetaClasses gather: [:class | self coreMethodsForClass: class]! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 00:53'!
toText

	^String streamContents: [ :strm | self printOn: strm]! !

!KomSqueakMapUrl methodsFor: 'printing' stamp: 'svp 5/9/2003 01:33'!
toText

	^String streamContents: [ :strm | self printOn: strm]! !

!VersionHistory methodsFor: 'printing' stamp: 'svp 6/26/2002 16:30'!
treeString
	"Answer a string that show the entire version history with
	each branch starting on a new line"

	^self treeStringStartingAt: self firstVersion! !

!VersionHistory methodsFor: 'printing' stamp: 'svp 6/26/2002 16:26'!
treeStringOn: strm startingAt: aVersion

	| tmp |
	tmp := self mainLineStartingAt: aVersion.
	tmp do: [ :ea | ea versionStringOn: strm. strm space; space ].
	strm cr.
	tmp do: 
		[ :ea | 
		(versions includes: ea branchNext)
			ifTrue: [self treeStringOn: strm startingAt: ea branchNext]].! !

!VersionHistory methodsFor: 'printing' stamp: 'svp 6/26/2002 11:34'!
treeStringStartingAt: aVersion

	| strm |
	strm := WriteStream on: ''.
	self treeStringOn: strm startingAt: aVersion.
	^strm contents! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/20/2003 16:02'!
validatePrerequisites
	"This checks that the default prerequisite fulfillments match the versions
	that we think are loaded"

	| text item start link end |
	text := '' asText.
	self 
		visitPrerequisites: 
			[ :preRL :pkgInfo |
			item := nil.
			preRL isPresent ifFalse: 
				[item := '- Prerequisite "', preRL name ,'" in ', 
					pkgInfo class name,
					' does not appear to be present in the image', 
					String cr, String cr].
			preRL isWrongVersionPresent ifTrue:
				[item := '- Prerequisite "', preRL name ,'" in ', 
					pkgInfo class name,
					' does not appear to be consistent with the loaded version', 
					String cr, String cr].
			(self isStable and: [preRL isCorrectVersionPresent and: [preRL isStable not]]) 
				ifTrue:
				[item := '- Prerequisite "', preRL name ,'" in ', 
					pkgInfo class name,
					' is present, however its maturity level is marked unstable', 
					String cr, String cr].

			item ifNotNil: 
				[link := TextDoIt new evalString: (pkgInfo class name, 
						' browsePrereq: ', preRL name printString).
				start := text size + 1.
				end := item size + start.
				text append: item.
				text addAttribute: link from: start to: end]]
		visited: Set new.
	text string isEmpty ifTrue: 
		[^self inform: 'All prerequisites are consistent with the versions in memory'].

	StringHolder new
		acceptContents: text;
		openLabel: 'Inconsistent Prerequisites'.
! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 00:54'!
version

	^version! !

!KomPackageUrl methodsFor: 'accessing' stamp: 'svp 5/9/2003 00:54'!
version: aString

	version := aString! !

!VersionHistory methodsFor: 'accessing' stamp: 'svp 6/26/2002 16:37'!
versionBefore: aVersion

	"Answer the version immediately preceeding aVersion."

	| tmp |
	(aVersion > '1' asVersion) ifFalse: [^nil].
	(versions includes: (tmp := aVersion previous)) ifFalse: [^nil].
	^tmp! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/5/2003 21:58'!
versionInfo

	^self releaseName, ' {', self buildNumberString, '}'! !

!PackageInfo methodsFor: '*KomPackaging' stamp: 'svp 5/5/2003 21:55'!
versionInfo

	^''! !

!VersionNumber methodsFor: 'printing' stamp: 'svp 5/5/2003 14:26'!
versionString

	^String streamContents: [ :strm | self versionStringOn: strm ]! !

!VersionNumber methodsFor: 'printing' stamp: 'svp 6/18/2002 17:23'!
versionStringOn: strm

	| first |
	first := true.
	numbers do: [ :ea |
		first ifFalse: [strm nextPut: $.].
		first := false.
		ea printOn: strm]
	! !

!VersionHistory methodsFor: 'accessing' stamp: 'svp 6/26/2002 16:37'!
versionsAfter: aVersion
	"Answer all the versions immediately following aVersion."

	| answer tmp |
	answer := Set new.
	tmp := aVersion next.
	(versions includes: aVersion next) ifTrue: [answer add: tmp].

	tmp := aVersion.
	[versions includes: (tmp := tmp branchNext)] whileTrue:
		[answer add: tmp].
	^answer! !

!KomPackageInfo methodsFor: 'as yet unclassified' stamp: 'svp 5/20/2003 15:55'!
visitPrerequisites: aBlock visited: visited

	| url |
	self prerequisites do:
		[ :arr |
		url := arr second asUrl.
		(visited includes: arr second) ifFalse:
			[visited add: arr second.
			aBlock value: url value: self.
			url installedPackageInfo ifNotNilDo:
				[ :pkgInfo | pkgInfo visitPrerequisites: aBlock visited: visited]]].! !
Smalltalk at: #FilePackageManager ifPresent: [ :p | p registerPackage: #KomPackaging].!
Smalltalk at: #KomPackageInfo ifPresent: [ :p | (p named: #KomPackaging) buildNumber: '36' asVersion].!